SystemOrganization addCategory: #ConfigurationOfA4BPForMass!

Object subclass: #ConfigurationOfA4BPForMass
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfA4BPForMass'!

!ConfigurationOfA4BPForMass class methodsFor: 'development support' stamp: 'NickPapoulias 2/15/2016 16:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfA4BPForMass class methodsFor: 'private' stamp: 'NickPapoulias 2/15/2016 16:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfA4BPForMass class methodsFor: 'private' stamp: 'NickPapoulias 2/15/2016 16:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfA4BPForMass class methodsFor: 'private' stamp: 'NickPapoulias 2/15/2016 16:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfA4BPForMass class methodsFor: 'metacello tool support' stamp: 'NickPapoulias 2/15/2016 16:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfA4BPForMass class methodsFor: 'loading' stamp: 'NickPapoulias 2/15/2016 16:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfA4BPForMass class methodsFor: 'loading' stamp: 'NickPapoulias 2/15/2016 16:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfA4BPForMass class methodsFor: 'loading' stamp: 'NickPapoulias 2/15/2016 16:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfA4BPForMass class methodsFor: 'accessing' stamp: 'NickPapoulias 2/15/2016 16:40'!
project

	^self new project! !

!ConfigurationOfA4BPForMass class methodsFor: 'development support' stamp: 'NickPapoulias 2/15/2016 16:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfA4BPForMass methodsFor: 'baselines' stamp: 'NickPapoulias 2/15/2016 18:03'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/ajperalt/A4BP/main/'.
		spec 
			project: 'Roassal2' with: [
				spec
					className: #ConfigurationOfRoassal2;
					repository: 'http://smalltalkhub.com/mc/ObjectProfile/Roassal2/main/' ];
			project: 'XMLParser' with: [
				spec
					className: #ConfigurationOfXMLParser;
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main/' ];
			project: 'XMLWriter' with: [
				spec
					className: #ConfigurationOfXMLWriter;
					repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLWriter/main/' ].
		spec 
			package: 'A4BP-core';
			package: 'A4BP-BPMN20-core' with: [
				spec requires: #('A4BP-core' ). ];
			package: #'A4BP-View' with: [
				spec requires: #('A4BP-core' ). ];
			package: #'A4BP-BPMN20-view' with: [
				spec requires: #(#'A4BP-View' ). ];
			package: #'A4BP-SimEngine-core' with: [
				spec requires: #('A4BP-core' ). ];
			package: #'A4BP-SimEngine-BPMN20' with: [
				spec requires: #(#'A4BP-SimEngine-core' ). ]].
! !

!ConfigurationOfA4BPForMass methodsFor: 'accessing' stamp: 'NickPapoulias 2/15/2016 16:40'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfA4BPForMass methodsFor: 'accessing' stamp: 'NickPapoulias 2/15/2016 16:40'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfA4BPForMass methodsFor: 'symbolic versions' stamp: 'NickPapoulias 2/15/2016 16:40'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfA4BPForMass methodsFor: 'versions' stamp: 'NickPapoulias 2/15/2016 17:07'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec 
			project: 'Roassal2' with: #stable;
			project: 'XMLParser' with: #stable;
			project: 'XMLWriter' with: #stable.
		spec 
			package: 'A4BP-core' with: 'A4BP-core-AlvaroJosePeraltaOcampo.84';
			package: 'A4BP-BPMN20-core' with: 'A4BP-BPMN20-core-AlvaroJosePeraltaOcampo.219';
			package: #'A4BP-SimEngine-core' with: 'A4BP-SimEngine-core-AlvaroJosePeraltaOcamop.88';
			package: #'A4BP-SimEngine-BPMN20' with: 'A4BP-SimEngine-BPMN20-AlvaroJosePeraltaOcamop.70'].
! !
